<?php

namespace SGalinski\SgMail\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Extbase\DomainObject\AbstractEntity;

/**
 * Mail domain model
 */
class Mail extends AbstractEntity {
	// Just some default values for better API calls.
	const PRIORITY_LOWEST = 0;
	const PRIORITY_LOW = 50;
	const PRIORITY_MEDIUM = 100;
	const PRIORITY_HIGH = 150;
	const PRIORITY_HIGHEST = 200;

	/**
	 * @var string
	 */
	protected $mail_subject = '';

	/**
	 * @var string
	 */
	protected $mail_body = '';

	/**
	 * @var string
	 */
	protected $to_address = '';

	/**
	 * @var string
	 */
	protected $from_address = '';

	/**
	 * @var bool
	 */
	protected $sent = FALSE;

	/**
	 * @var int
	 */
	protected $priority = 0;

	/**
	 * @return string
	 */
	public function getMailSubject() {
		return $this->mail_subject;
	}

	/**
	 * @param string $mail_subject
	 * @return void
	 */
	public function setMailSubject($mail_subject) {
		$this->mail_subject = $mail_subject;
	}

	/**
	 * @return string
	 */
	public function getMailBody() {
		return $this->mail_body;
	}

	/**
	 * @param string $mail_body
	 * @return void
	 */
	public function setMailBody($mail_body) {
		$this->mail_body = $mail_body;
	}

	/**
	 * @return string
	 */
	public function getToAddress() {
		return $this->to_address;
	}

	/**
	 * @param string $to_address
	 * @return void
	 */
	public function setToAddress($to_address) {
		$this->to_address = $to_address;
	}

	/**
	 * @return string
	 */
	public function getFromAddress() {
		return $this->from_address;
	}

	/**
	 * @param string $from_address
	 * @return void
	 */
	public function setFromAddress($from_address) {
		$this->from_address = $from_address;
	}

	/**
	 * @return bool
	 */
	public function getSent() {
		return $this->sent;
	}

	/**
	 * @param bool $sent
	 * @return void
	 */
	public function setSent($sent) {
		$this->sent = ($sent === TRUE);
	}

	/**
	 * @return int
	 */
	public function getPriority() {
		return $this->priority;
	}

	/**
	 * @param int $priority
	 * @return void
	 */
	public function setPriority($priority) {
		$this->priority = (int) $priority;
	}
}
