<?php

namespace SGalinski\SgMail\Service;

use \TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * MailTemplateService
 */
class MailTemplateService {

	/**
	 * @var array
	 */
	private static $registerArray = [];

	/**
	 * @todo Code-Dokumentation, Parameter vergessen bei param
	 *
	 * @param string $extension
	 * @param string $extensionKey
	 * @param string $template
	 * @param array $marker
	 * @return string
	 */
	public static function registerTemplate($extension, $templateName, $templatePath, $description, array $marker) {

		MailTemplateService::$registerArray[$extension][$extension . '_' . $templateName] = [
			'templatePath' => $templatePath,
			'description' => $description,
			'marker' => $marker,
			'extension' => $extension,
			'templateName' => $templateName
		];

		$defaultLangFile = $templatePath . 'en.sg_mail.locallang.html';
		if (!file_exists($defaultLangFile)) {
			$langFileContent = 'TEST';
			file_put_contents($defaultLangFile, $langFileContent);
		}
	}

	/**
	 * @todo Code-Dokumentation
	 *
	 * @return array
	 */
	public static function getRegisterArray() {
		return self::$registerArray;
	}

	/**
	 * @todo Code-Dokumentation, Parameter vergessen bei param
	 *
	 * @param string $language
	 * @param string $templateKey
	 * @param string $extensionKey
	 * @param string $toAddress
	 * @param string $fromAddress
	 * @param string $subject
	 * @param string $content
	 */
	public static function sendEmail(
		$language, $templateKey, $extensionKey, $toAddress, $fromAddress, $subject, array $content = []
	) {
		// Set Email Content
		$registerArray = MailTemplateService::getRegisterArray();
		$templateEntry = $registerArray[$extensionKey][$templateKey];

		$objectManager = GeneralUtility::makeInstance(ObjectManager::class);
		// @todo verwende bitte StandaloneView::class
		$emailView = $objectManager->get('TYPO3\\CMS\\Fluid\\View\\StandaloneView');
		$emailView->setTemplatePathAndFilename($templateEntry['templatePath'] . $language . '.sg_mail.locallang.html');
		$emailView->assignMultiple($content);
		$emailBody = $emailView->render();

		$mail = GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Mail\\MailMessage');
		$mail->setFrom($fromAddress);
		$mail->setTo($toAddress);
		$mail->setSubject($subject);
		$mail->setBody($emailBody, 'text/html');
		$mail->send();
	}
}
